/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.workflow.action;

import java.util.List;

import jp.mosp.common.CommonConst;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.utils.StringUtil;
import jp.mosp.kintai.common.action.MosPWorkflowAction;
import jp.mosp.kintai.workflow.dto.AmRouteDto;
import jp.mosp.kintai.workflow.dto.PmAttendanceDto;
import jp.mosp.kintai.workflow.vo.AttendanceRouteCardVo;

/**
 * @author yoshida
 *
 */
public class AttendanceRouteCardAction extends MosPWorkflowAction {
	
	// コマンド
	private static final String	CMD_ROUTE_CARD_SHOW		= "S2835";	// 表示(追加)
	private static final String	CMD_ROUTE_CARD_SELECT	= "S2836";	// 表示(選択)
	private static final String	CMD_ROUTE_CARD_INSERT	= "S2837";	// 登録
	private static final String	CMD_ROUTE_CARD_UPDATE	= "S2838";	// 更新
																	
	
	/**
	 * コンストラクタ
	 */
	public AttendanceRouteCardAction() {
		super();
	}
	
	/**
	 * アクション
	 */
	public void action() throws Exception {
		// VOの取得及び設定
		prepareVo(false);
		// 初期処理
		init();
		// コマンド毎の処理
		if (cmd.equals(CMD_ROUTE_CARD_SHOW)) {
			// 表示
			show();
		} else if (cmd.equals(CMD_ROUTE_CARD_SELECT)) {
			// 表示(キーで情報を検索)
			select();
		} else if (cmd.equals(CMD_ROUTE_CARD_INSERT)) {
			// 新規登録
			insert();
		} else if (cmd.equals(CMD_ROUTE_CARD_UPDATE)) {
			// 更新
			update();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new AttendanceRouteCardVo();
	}
	
	@Override
	protected void init() throws Exception {
		// DBコネクション取得
		getConnection();
		// SYSTEM権限確認
		confirmSystemAuth();
		AttendanceRouteCardVo vo = (AttendanceRouteCardVo)getVo();
		// 事業所コード一覧
		vo.aryPltOffice = StringUtil.addArrayFirstRowSpace(getOfficeArrayAll());
		// 所属コード一覧
		vo.aryPltSection = StringUtil.addArrayFirstRowSpace(getSectionArrayAll());
		// 勤怠用承認ルートコード一覧
		vo.aryPltRoute = getRouteArrayAvailable();
		// 人事基本情報
		vo.aryUser = part().human().getBasisArrayAll();
		// 所属確認用配列
		vo.aryBelongSection = part().human().getBasisArrayAllWithSectionCode();
		vo.aryBelongOffice = part().human().getBasisArrayAllWithOfficeCode();
		vo.setParams(request);
	}
	
	@Override
	protected void show() {
		AttendanceRouteCardVo vo = (AttendanceRouteCardVo)getVo();
		vo.setDefaultValues();
		// モード設定
		setMode();
	}
	
	@Override
	protected void select() throws Exception {
		AttendanceRouteCardVo vo = (AttendanceRouteCardVo)getVo();
		// データの取得
		PmAttendanceDto dto = pmAttendDao().findForKey(key1);
		chkExist(dto);
		// VOに情報をセット
		vo.setFields(dto);
		vo.setMode(AttendanceRouteCardVo.MODE_UPDATE);
		// セッションにDTOをセット
		setSessionDto(dto);
	}
	
	@Override
	protected void insert() throws Exception {
		AttendanceRouteCardVo vo = (AttendanceRouteCardVo)getVo();
		// パラメータの妥当性確認
		vo.validate();
		// 存在チェック
		chkDuplicate(pmAttendDao().findForCondition(vo.getPltSection(), vo.getTxtKCode(), vo.getPltRouteCode()));
		if (StringUtil.isNotNull(vo.getTxtKCode())) {
			chkDuplicate(pmAttendDao().findForKCode(vo.getTxtKCode()));
		}
		// 最大値をセット
		String maxEno = pmAttendDao().findForMax();
		if (StringUtil.isNull(maxEno)) {
			maxEno = "-1";
		} else {
			pmAttendDao().findForUpdate(maxEno);
		}
		// DTOの準備
		PmAttendanceDto dto = new PmAttendanceDto();
		vo.setPltDelete(String.valueOf(MospConst.DELETE_FLAG_OFF));
		vo.setDtoFields(dto);
		dto.setRouteId(Integer.parseInt(maxEno) + 1);
		// データの挿入
		pmAttendDao().insert(dto);
		// DTOの再取得
		dto = pmAttendDao().findForKey(String.valueOf(dto.getRouteId()));
		// コミット
		commit();
		// モード設定
		vo.setMode(AttendanceRouteCardVo.MODE_UPDATE);
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_INSERT, ""));
		// セッションにDTOをセット
		setSessionDto(dto);
	}
	
	@Override
	protected void update() throws Exception {
		// DTOの取得
		PmAttendanceDto dto = (PmAttendanceDto)getSessionDto();
		AttendanceRouteCardVo vo = (AttendanceRouteCardVo)getVo();
		vo.setHidRouteid(String.valueOf(dto.getRouteId()));
		// パラメータの妥当性確認
		vo.validate();
		// 排他確認
		chkExclusive(dto, pmAttendDao().findForUpdate(vo.getHidRouteid()));
		// 最大値をセット
		String maxRouteId = pmAttendDao().findForMax();
		if (StringUtil.isNull(maxRouteId)) {
			maxRouteId = "-1";
		} else {
			pmAttendDao().findForUpdate(maxRouteId);
		}
		if (pmAttendDao().findForUpdate(String.valueOf(dto.getRouteId())) != null) {
			dto.setDeleteFlag(MospConst.DELETE_FLAG_ON);
			// 論理削除
			pmAttendDao().update(dto);
		}
		// DTOの準備
		vo.setDtoFields(dto);
		dto.setRouteId(Integer.parseInt(maxRouteId) + 1);
		// データの更新
		pmAttendDao().insert(dto);
		// DTOの再取得
		PmAttendanceDto retDto = pmAttendDao().findForKey(String.valueOf(dto.getRouteId()));
		chkUpdate(retDto);
		// コミット
		commit();
		// モード設定
		vo.setMode(AttendanceRouteCardVo.MODE_UPDATE);
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_UPDATE, ""));
		// セッションにDTOをセット
		setSessionDto(retDto);
	}
	
	/**
	 * 勤怠用承認ルートコード一覧（一次、最終）
	 * @return	String[][]	ルートコード配列
	 * @throws Exception 	例外処理が発生した場合
	 */
	private String[][] getRouteArrayAvailable() throws Exception {
		// 情報の取得
		List<AmRouteDto> listRoute = routeDao().findForAttendanceRoute();
		// 配列の作成		
		String[][] aryRoute = new String[listRoute.size()][2];
		String[][] aryUnit = getCurrentUnitArray();
		for (int i = 0; i < aryRoute.length; i++) {
			aryRoute[i][0] = listRoute.get(i).getRtCode();
			StringBuffer sb = new StringBuffer();
			sb.append(CommonConst.MSG_APPROVAL_FIRST);
			sb.append(StringUtil.surroundBracket(StringUtil.getCodeName(listRoute.get(i).getLayer1(), aryUnit)));
			sb.append(CommonConst.MSG_APPROVAL_SECOND);
			sb.append(StringUtil.surroundBracket(StringUtil.getCodeName(listRoute.get(i).getLastLayer(), aryUnit)));
			aryRoute[i][1] = sb.toString();
		}
		return aryRoute;
	}
	
	/**
	 * モード設定
	 */
	private void setMode() {
		AttendanceRouteCardVo vo = (AttendanceRouteCardVo)getVo();
		// モード設定
		if (vo.aryPltRoute.length == 0) {
			vo.setMode(AttendanceRouteCardVo.MODE_IMPOSSIBLE);
		} else {
			vo.setMode(AttendanceRouteCardVo.MODE_INSERT);
		}
	}
	
}
